// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonFitList.h"
#include "IIntensityNormalizer.pypp.h"

namespace bp = boost::python;

struct IIntensityNormalizer_wrapper : IIntensityNormalizer, bp::wrapper< IIntensityNormalizer > {

    IIntensityNormalizer_wrapper()
    : IIntensityNormalizer()
      , bp::wrapper< IIntensityNormalizer >(){
        // null constructor
        m_pyobj = 0;
    }

    virtual ::IIntensityNormalizer * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual ::OutputData< double > * createNormalizedData( ::OutputData< double > const & data ) const {
        bp::override func_createNormalizedData = this->get_override( "createNormalizedData" );
        return func_createNormalizedData( boost::ref(data) );
    }

    virtual void setMaximumIntensity( double arg0 ){
        bp::override func_setMaximumIntensity = this->get_override( "setMaximumIntensity" );
        func_setMaximumIntensity( arg0 );
    }

    virtual bool areParametersChanged(  ) {
        if( bp::override func_areParametersChanged = this->get_override( "areParametersChanged" ) )
            return func_areParametersChanged(  );
        else{
            return this->IParameterized::areParametersChanged(  );
        }
    }
    
    bool default_areParametersChanged(  ) {
        return IParameterized::areParametersChanged( );
    }

    virtual void clearParameterPool(  ) {
        if( bp::override func_clearParameterPool = this->get_override( "clearParameterPool" ) )
            func_clearParameterPool(  );
        else{
            this->IParameterized::clearParameterPool(  );
        }
    }
    
    void default_clearParameterPool(  ) {
        IParameterized::clearParameterPool( );
    }

    virtual ::ParameterPool * createParameterTree(  ) const  {
        if( bp::override func_createParameterTree = this->get_override( "createParameterTree" ) )
            return func_createParameterTree(  );
        else{
            return this->IParameterized::createParameterTree(  );
        }
    }
    
    ::ParameterPool * default_createParameterTree(  ) const  {
        return IParameterized::createParameterTree( );
    }

    virtual void printParameters(  ) const  {
        if( bp::override func_printParameters = this->get_override( "printParameters" ) )
            func_printParameters(  );
        else{
            this->IParameterized::printParameters(  );
        }
    }
    
    void default_printParameters(  ) const  {
        IParameterized::printParameters( );
    }

    virtual bool setParameterValue( ::std::string const & name, double value ) {
        if( bp::override func_setParameterValue = this->get_override( "setParameterValue" ) )
            return func_setParameterValue( name, value );
        else{
            return this->IParameterized::setParameterValue( name, value );
        }
    }
    
    bool default_setParameterValue( ::std::string const & name, double value ) {
        return IParameterized::setParameterValue( name, value );
    }

    virtual void setParametersAreChanged(  ) {
        if( bp::override func_setParametersAreChanged = this->get_override( "setParametersAreChanged" ) )
            func_setParametersAreChanged(  );
        else{
            this->IParameterized::setParametersAreChanged(  );
        }
    }
    
    void default_setParametersAreChanged(  ) {
        IParameterized::setParametersAreChanged( );
    }

    PyObject* m_pyobj;

};

void register_IIntensityNormalizer_class(){

    { //::IIntensityNormalizer
        typedef bp::class_< IIntensityNormalizer_wrapper, bp::bases< IParameterized >, std::auto_ptr< IIntensityNormalizer_wrapper >, boost::noncopyable > IIntensityNormalizer_exposer_t;
        IIntensityNormalizer_exposer_t IIntensityNormalizer_exposer = IIntensityNormalizer_exposer_t( "IIntensityNormalizer", "Interface to OutputData normalizers." );
        bp::scope IIntensityNormalizer_scope( IIntensityNormalizer_exposer );
        { //::IIntensityNormalizer::clone
        
            typedef ::IIntensityNormalizer * ( ::IIntensityNormalizer::*clone_function_type)(  ) const;
            
            IIntensityNormalizer_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IIntensityNormalizer::clone) )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IIntensityNormalizer::createNormalizedData
        
            typedef ::OutputData<double> * ( ::IIntensityNormalizer::*createNormalizedData_function_type)( ::OutputData<double> const & ) const;
            
            IIntensityNormalizer_exposer.def( 
                "createNormalizedData"
                , bp::pure_virtual( createNormalizedData_function_type(&::IIntensityNormalizer::createNormalizedData) )
                , ( bp::arg("data") )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IIntensityNormalizer::setMaximumIntensity
        
            typedef void ( ::IIntensityNormalizer::*setMaximumIntensity_function_type)( double ) ;
            
            IIntensityNormalizer_exposer.def( 
                "setMaximumIntensity"
                , bp::pure_virtual( setMaximumIntensity_function_type(&::IIntensityNormalizer::setMaximumIntensity) )
                , ( bp::arg("arg0") ) );
        
        }
        { //::IParameterized::areParametersChanged
        
            typedef bool ( ::IParameterized::*areParametersChanged_function_type)(  ) ;
            typedef bool ( IIntensityNormalizer_wrapper::*default_areParametersChanged_function_type)(  ) ;
            
            IIntensityNormalizer_exposer.def( 
                "areParametersChanged"
                , areParametersChanged_function_type(&::IParameterized::areParametersChanged)
                , default_areParametersChanged_function_type(&IIntensityNormalizer_wrapper::default_areParametersChanged) );
        
        }
        { //::IParameterized::clearParameterPool
        
            typedef void ( ::IParameterized::*clearParameterPool_function_type)(  ) ;
            typedef void ( IIntensityNormalizer_wrapper::*default_clearParameterPool_function_type)(  ) ;
            
            IIntensityNormalizer_exposer.def( 
                "clearParameterPool"
                , clearParameterPool_function_type(&::IParameterized::clearParameterPool)
                , default_clearParameterPool_function_type(&IIntensityNormalizer_wrapper::default_clearParameterPool) );
        
        }
        { //::IParameterized::createParameterTree
        
            typedef ::ParameterPool * ( ::IParameterized::*createParameterTree_function_type)(  ) const;
            typedef ::ParameterPool * ( IIntensityNormalizer_wrapper::*default_createParameterTree_function_type)(  ) const;
            
            IIntensityNormalizer_exposer.def( 
                "createParameterTree"
                , createParameterTree_function_type(&::IParameterized::createParameterTree)
                , default_createParameterTree_function_type(&IIntensityNormalizer_wrapper::default_createParameterTree)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IParameterized::printParameters
        
            typedef void ( ::IParameterized::*printParameters_function_type)(  ) const;
            typedef void ( IIntensityNormalizer_wrapper::*default_printParameters_function_type)(  ) const;
            
            IIntensityNormalizer_exposer.def( 
                "printParameters"
                , printParameters_function_type(&::IParameterized::printParameters)
                , default_printParameters_function_type(&IIntensityNormalizer_wrapper::default_printParameters) );
        
        }
        { //::IParameterized::setParameterValue
        
            typedef bool ( ::IParameterized::*setParameterValue_function_type)( ::std::string const &,double ) ;
            typedef bool ( IIntensityNormalizer_wrapper::*default_setParameterValue_function_type)( ::std::string const &,double ) ;
            
            IIntensityNormalizer_exposer.def( 
                "setParameterValue"
                , setParameterValue_function_type(&::IParameterized::setParameterValue)
                , default_setParameterValue_function_type(&IIntensityNormalizer_wrapper::default_setParameterValue)
                , ( bp::arg("name"), bp::arg("value") ) );
        
        }
        { //::IParameterized::setParametersAreChanged
        
            typedef void ( ::IParameterized::*setParametersAreChanged_function_type)(  ) ;
            typedef void ( IIntensityNormalizer_wrapper::*default_setParametersAreChanged_function_type)(  ) ;
            
            IIntensityNormalizer_exposer.def( 
                "setParametersAreChanged"
                , setParametersAreChanged_function_type(&::IParameterized::setParametersAreChanged)
                , default_setParametersAreChanged_function_type(&IIntensityNormalizer_wrapper::default_setParametersAreChanged) );
        
        }
    }

}
